import React, { memo } from 'react';
import { useDispatch } from 'react-redux';
import { useCachedSelector, useGetErrors, useWillMount } from '../hooks';
import controlActions from '../actions/controls';
import { BLUR, FOCUS, INPUT, MOUNT } from '../constants/events';
import { getValue /*, hasBeenValidated, isFormInitialized*/ } from '../store/reducers';
function Checkbox(_a) {
    var autoFocus = _a.autoFocus, className = _a.className, disabled = _a.disabled, id = _a.id, model = _a.model, _b = _a.onChange, onChange = _b === void 0 ? function () { } : _b, parseValue = _a.parseValue, style = _a.style, validateOn = _a.validateOn, _c = _a.validator, validator = _c === void 0 ? function () { } : _c;
    useWillMount(function () { return controlActions.mountModel(model, parseValue, validateOn === MOUNT, validator); });
    var dispatch = useDispatch();
    var value = useCachedSelector(getValue, model) || '';
    var errors = useGetErrors(model, value);
    console.log('RENDERING: checkbox', model, errors);
    var handleOnChange = function (e) {
        dispatch(controlActions.setValue(model, e.target.checked));
        onChange(model, e.target.checked);
    };
    var getClassName = function () {
        return [className, errors.length < 1] // && isValidated ? `CHCl3Error ${model}-CHCl3Error` : undefined]
            .join(' ')
            .trim();
    };
    var markValidated = function () { }; // isValidated || setValidated(model);
    return (React.createElement("input", { autoFocus: autoFocus, checked: (Array.isArray(value) ? value.every(Boolean) : value) || false, className: getClassName(), disabled: disabled, id: id, onBlur: validateOn === BLUR ? markValidated : undefined, onChange: handleOnChange, onClick: validateOn === INPUT ? markValidated : undefined, onFocus: validateOn === FOCUS ? markValidated : undefined, style: style, type: "checkbox" }));
}
/*
const mapStateToProps = (state: Store.CombinedState, {model}: PropTypes) => ({
  value: getValue(state, model),
  errors: [],
  // initialized: isFormInitialized(state),
});

const mapDispatchToProps = {
  deleteValue: controlActions.deleteValue,
  markValidated: controlActions.markValidated,
  mountModel: controlActions.mountModel,
  setErrors: controlActions.setErrors,
  setValue: controlActions.setValue,
  updateValue: controlActions.updateValue,
};
*/
export default memo(Checkbox);
//# sourceMappingURL=Checkbox.js.map