import React, { memo } from 'react';
import { useDispatch } from 'react-redux';
import { useCachedSelector, useGetErrors, useWillMount } from '../hooks';
import controlActions from '../actions/controls';
import { BLUR, FOCUS, INPUT, MOUNT } from '../constants/events';
// import {getValue2 as getValue, isFormInitialized, hasBeenValidated, hasError} from '../store/reducers';
import { getValue /*, hasBeenValidated, isFormInitialized*/ } from '../store/reducers';
function DataList(_a) {
    var autoFocus = _a.autoFocus, className = _a.className, disabled = _a.disabled, id = _a.id, model = _a.model, _b = _a.onChange, onChange = _b === void 0 ? function () { } : _b, options = _a.options, parseValue = _a.parseValue, placeholder = _a.placeholder, style = _a.style, validateOn = _a.validateOn, validator = _a.validator;
    useWillMount(function () { return controlActions.mountModel(model, parseValue, validateOn === MOUNT, validator); });
    var dispatch = useDispatch();
    var value = useCachedSelector(getValue, model) || '';
    var errors = useGetErrors(model, value);
    console.log('RENDERING: datalist', model);
    var handleOnChange = function (e) {
        dispatch(controlActions.setValue(model, e.target.value));
        onChange(model, e.target.value);
    };
    var getClassName = function () {
        return [className, errors.length < 1] // && isValidated ? `CHCl3Error ${model}-CHCl3Error` : undefined]
            .join(' ')
            .trim();
    };
    var markValidated = function () { }; // isValidated || setValidated(model);
    return (React.createElement("div", null,
        React.createElement("input", { autoFocus: autoFocus, className: getClassName(), disabled: disabled, id: id, list: model, onBlur: validateOn === BLUR ? markValidated : undefined, onChange: handleOnChange, onFocus: validateOn === FOCUS ? markValidated : undefined, onKeyUp: validateOn === INPUT ? markValidated : undefined, placeholder: placeholder, style: style, value: value || '' }),
        React.createElement("datalist", { id: model }, options.map(function (option) { return (React.createElement("option", { key: option.value, value: option.value, disabled: option.disabled }, option.name)); }))));
}
/*
const mapStateToProps = (state: Store.CombinedState, {model}: PropTypes) => ({
  hasError: hasError(state, model),
  initialized: isFormInitialized(state),
  isValidated: hasBeenValidated(state, model),
  value: getValue(state, model),
});

const mapDispatchToProps = {
  markValidated: controlActions.markValidated,
  mountModel: controlActions.mountModel,
  setErrors: controlActions.setErrors,
  setValue: controlActions.setValue,
};
*/
export default memo(DataList);
//# sourceMappingURL=DataList.js.map