import { __assign } from "tslib";
import React, { useEffect, useState } from 'react';
import { useDispatch, useSelector, Provider } from 'react-redux';
import controlActions from '../actions/controls';
import formActions from '../actions/form';
import reducers, { getFormValues /*, hasFormErrors*/ } from '../store/reducers';
import thunk from 'redux-thunk';
import { createStore, applyMiddleware } from 'redux';
function Form(_a) {
    var afterSubmitState = _a.afterSubmitState, children = _a.children, className = _a.className, id = _a.id, _b = _a.initialState, initialState = _b === void 0 ? {} : _b, _c = _a.onChange, onChange = _c === void 0 ? function () { } : _c, _d = _a.onReset, onReset = _d === void 0 ? function () { } : _d, onResetState = _a.onResetState, onSubmit = _a.onSubmit, _e = _a.onSubmitFailed, onSubmitFailed = _e === void 0 ? function () { } : _e, style = _a.style, _f = _a.validators, validators = _f === void 0 ? {} : _f;
    console.log('RENDERING: form');
    var dispatch = useDispatch();
    useEffect(function () {
        dispatch(controlActions.initializeState(initialState, validators));
    }, []);
    var values = useSelector(function (state) { return getFormValues(state); });
    var handleSubmit = function (event) {
        event.preventDefault();
        event.stopPropagation();
        // if (hasFormErrors) {
        //   showErrors();
        //   return;
        // }
        // this.props.setPending(this.props.model);
        // setSubmitting();
        Promise.resolve()
            .then(function () { return onSubmit(values); })
            .then(function () {
            if (afterSubmitState && false) {
                dispatch(controlActions.initializeState(afterSubmitState, validators));
            }
            // setSubmitted();
        })
            .catch(function (err) {
            // setSubmitFailed();
            onSubmitFailed(err);
        })
            .finally(function () { return dispatch(formActions.resetSubmit()); });
    };
    var handleReset = function (event) {
        event.preventDefault();
        event.stopPropagation();
        dispatch(controlActions.initializeState(onResetState || initialState, validators));
        onReset();
    };
    return (React.createElement("form", { className: className, onChange: onChange, onReset: handleReset, onSubmit: handleSubmit, style: style, id: id }, children));
}
/*
const mapStateToProps = (state: Store.CombinedState) => ({
  // hasFormErrors: hasFormErrors(state),
  getValues: () => getFormValues(state),
});

const mapDispatchToProps = {
  initializeState: controlActions.initializeState,
  // setPending: controlActions.setPending,
  // showErrors: controlActions.showErrors,

  resetSubmit: formActions.resetSubmit,
  // setSubmitFailed: formActions.setSubmitFailed,
  // setSubmitted: formActions.setSubmitted,
  // setSubmitting: formActions.setSubmitting,
};
*/
function StoreProvider(props) {
    var store = useState(createStore(reducers, applyMiddleware(thunk)))[0];
    return (React.createElement(Provider, { store: store },
        React.createElement(Form, __assign({}, props))));
}
export default StoreProvider;
//# sourceMappingURL=Form.js.map