import React, { memo } from 'react';
import { useDispatch } from 'react-redux';
import { useCachedSelector, useGetErrors, useWillMount } from '../hooks';
import controlActions from '../actions/controls';
import { BLUR, FOCUS, INPUT, MOUNT } from '../constants/events';
//import {getValue2 as getValue/*, hasError*/} from '../store/reducers';
import { getValue /*, hasBeenValidated, isFormInitialized*/ } from '../store/reducers';
function RadioButton(_a) {
    var autoFocus = _a.autoFocus, className = _a.className, disabled = _a.disabled, id = _a.id, model = _a.model, _b = _a.onChange, onChange = _b === void 0 ? function () { } : _b, parseValue = _a.parseValue, placeholder = _a.placeholder, style = _a.style, validateOn = _a.validateOn, validator = _a.validator, value = _a.value;
    useWillMount(function () { return controlActions.mountModel(model, parseValue, validateOn === MOUNT, validator); });
    var dispatch = useDispatch();
    var checked = useCachedSelector(getValue, model) || '';
    var errors = useGetErrors(model, value);
    console.log('RENDERING: radiobutton', model);
    var handleOnChange = function (e) {
        dispatch(controlActions.setValue(model, e.target.value));
        onChange(model, e.target.value);
    };
    var getClassName = function () {
        return [className, errors.length < 1] // && isValidated ? `CHCl3Error ${model}-CHCl3Error` : undefined]
            .join(' ')
            .trim();
    };
    var markValidated = function () { }; // isValidated || setValidated(model);
    return (React.createElement("input", { autoFocus: autoFocus, checked: checked === value, className: getClassName(), disabled: disabled, id: id, onBlur: validateOn === BLUR ? markValidated : undefined, onChange: handleOnChange, onFocus: validateOn === FOCUS ? markValidated : undefined, onKeyUp: validateOn === INPUT ? markValidated : undefined, placeholder: placeholder, style: style, type: "radio", value: value }));
}
/*
const mapStateToProps = (state: Store.CombinedState, {model}: PropTypes) => ({
  checked: getValue(state, model),
  // hasError: hasError(state, model),
  // parseValue: (x: string | number) => x, // disable parseValue for radio-buttons
});

const mapDispatchToProps = {
  markValidated: controlActions.markValidated,
  mountModel: controlActions.mountModel,
  setErrors: controlActions.setErrors,
  setValue: controlActions.setValue,
};
*/
export default memo(RadioButton);
//# sourceMappingURL=RadioButton.js.map