import { __spreadArrays } from "tslib";
import { useMemo } from 'react';
import { getValidators } from '../store/reducers';
import { useCachedSelector } from '.';
export default (function (model, value) {
    var validators = useCachedSelector(getValidators, model);
    return useMemo(function () {
        return validators.reduce(function (acc, validate) {
            var validation = validate(value);
            if (validation) {
                var isValid = validation[0], message = validation[1];
                if (!isValid) {
                    return __spreadArrays(acc, [message]);
                }
            }
            return acc;
        }, []);
    }, [value]);
});
//# sourceMappingURL=useGetErrors.js.map